/// <reference path="../App.js" />
// global app
var baseURL = "";
var authURL = baseURL + "/services/api/auth";
var assetURL = baseURL + "/services/api/asset/all" ;
var fundURL = baseURL + "/services/api/fund";
var deliverableURL = baseURL + "/services/api/deliverable/";
var submissionURL = baseURL + "/services/api/submission/asset/";
var submissionHistoryURL = baseURL + "/services/api/submission/asset/" ;
var deleteMetricValuesURL = baseURL + "/services/api/submission/metricvalues/delete/" ;
var deleteSubmissionURL = baseURL + "/services/api/submission/" ;
var submissionDeliverableURL = baseURL + "/services/api/submission/deliverableRequest/" ;
var userServiceURL = baseURL + "/services/api/user" ;
var updateSubmissionURL = baseURL + "/services/api/submission/" ;
var fileURL = baseURL + "/services/api/file/" ;
var selectedBGColor = "chocolate";

var customStorage;
var groupCount = 1;
var dateGroupCount = 1;
var scenarioCount = 1;
var periodCount = 1;
var deliverableRequestArray;
var submissionHistoryArray;
var selectedDeliverableRequest;
var selectedSubmission;

var loadedDataGroup = false;
var dataGroupArray = [];
var dataCounter = 0;
var DEFAULT_METRIC_VALUE_LENGTH = 0;
var loadedDateGroup = false;
var DRAFT_STATUS = 1;
var TRANSACTED_STATUS = 5;
var PENDING_STATUS = 2;

var dateArray = [];
var dateCounter = 0;

var loadedScenario = false;
var scenarioArray = [];
var scenarioCounter = 0;

var loadedPeriodType = false;
var periodArray = [];
var periodCounter = 0;
var selectedAsset;
var customStorage;

var assetArray;
var selectedAsset;
var selectedAssetId;
var submissionId = 0;

var override = "false";
var colorCodes = ["#9ebd9e","#dd855c","#745151",
				"#00aba9","#a200ff","#1ba1e2","#f09609","#6b3e26",
				"#363636","#3b5998","#8b9dc3","#636363","#003333",
				"#ffa500","#272d70","#3a5976","#3b5998","#383838","#2d5867","#1e2e4d","#000d11","#2c003a"];

var deliverableReqId = 0;

var selectedTab = "deliverable";

var activeTab = ".deliverable";

(function() {
	'use strict';

	// The initialize function must be run each time a new page is loaded
	Office.initialize = function(reason) {
		$(document).ready(function() {
			app.initialize();
                        hideAll();
//                        getDeliverableRequest(); 
        //                 initializeAppData();           
			 //detectBrowser();
		});
	};

})();

$(function() {

$(window).load(function() {
  // When the page has loaded
   hideAll();
  $(".body-el").show();
  $("#url").val(localStorage.getItem("baseUrl"));
});

});

function hideAll(){

	$(".wrapper-class").hide();
	$(".submit-success").hide();
	$(".upcoming-header").hide();
	$(".history-sub").hide();
  $(".logout-screen").hide();
  $(".submit-box").hide();
}


   $(function (){

            $(document).on("click", "#refresh", function() {
                 
                   getAsset();                   
                         

             });
                   
   }) ;




   $(function () {

              $(document).on("click", ".submission-tab", function (){
                    
                        updateTabs(".submission", activeTab);
                        $(".asset-select").show();
                        $(".assetSelect").css("display", "block");
                        $(".submit-success").hide();
                        $(".logout-screen").hide();
                        $(".submit-box").hide();
                        $(".submit-box").css("display", "none");                        
                        $(".deliverable-feed").css("display", "block");
                        $(".logout-screen").css("display", "none");
                        selectedTab = "submission" ;
                        activeTab = ".submission" ;
                          
                        if($(".refresh-back").hasClass("fa-arrow-left")) {
                           $(".refresh-back").removeClass("fa-arrow-left back-button");
                           $(".refresh-back").addClass("fa-refresh");
                         }
                                               
                         getSubmissionHistory();
                   
               });
   });



   $(function () {

                $(document).on("click", "#logout-button", function (){
               
                  app.showNotification('Signing Out ........', '');
                  localStorage.removeItem('url');
                  localStorage.removeItem('hashCode');
                  clearSession();
  
              }) ;

           });


   $(function () {

              $(document).on("click", ".deliverable-tab", function (){

                         
                         updateTabs(".deliverable", activeTab);
                         
                         $(".asset-select").show();
                         $(".assetSelect").css("display", "block");
                         $(".submit-success").hide();          
                         $(".submission-feed").html("");
                         $(".logout-screen").css("display", "none");
                         $(".submit-box").hide();
                         $(".submit-box").css("display", "none");
                         $(".deliverable-feed").css("display", "block");
 
                         selectedTab = "deliverable" ;     
                         activeTab = ".deliverable" ;

                            if($(".refresh-back").hasClass("fa-arrow-left")) {
                           	$(".refresh-back").removeClass("fa-arrow-left back-button");
                           	$(".refresh-back").addClass("fa-refresh");
                     }
   
                        
                         getDeliverableRequest(selectedAssetId);

                    });
   });



   


    function updateTabs(tab1, tab2){

                 if($(tab1+"-tab").hasClass("col-xs-2")){

                          $(tab1+"-tab").removeClass("col-xs-2");
                          $(tab1+"-tab").addClass("col-xs-8");

                          $(tab2+"-tab").removeClass("col-xs-8");
                          $(tab2+"-tab").addClass("col-xs-2");
                          $(tab2+"-icon").css("margin-top","14px");
                          $(tab2+"-tab").css("background-color","lightgrey");
                          $(tab2+"-text").css("display","none");



                          $(tab1+"-text").css("display","block");
                          $(tab1+"-icon").css("float","left");
                          $(tab1+"-tab").css("background-color","white");

                     }



   }

function resetGlobal(){

 groupCount = 1;
 dateGroupCount = 1;
 scenarioCount = 1;
 periodCount = 1;
 loadedDataGroup = false;
 dataGroupArray = [];
 dataCounter = 0;

 loadedDateGroup = false;
 dateArray = [];
 dateCounter = 0;

 loadedScenario = false;
 scenarioArray = [];
 scenarioCounter = 0;

 loadedPeriodType = false;
 periodArray = [];
 periodCounter = 0;

 resetGlobalVars();



}

$(function() {

	$(".logout-tab").click(function() {

                       getUserDetails();

		//	app.showNotification('Signing Out ........', '');
	//	localStorage.removeItem('url');
	//	localStorage.removeItem('hashCode');

	//	clearSession();
              
                  $(".submission-feed").html("");
                  $(".deliverable-feed").html("");
                  $(".assetSelect").css("display", "none");
                  $(".deliverable-feed").css("display", "none");
                  $(".logout-screen").css("display", "block");
                  $(".asset-select").hide(); 
                  $(".submit-success").hide();      
                  $(".submit-box").hide();
                  $(".submit-box").css("display", "none");
                  $(".deliverable-feed").css("display", "none");
                  updateTabs(".logout", activeTab);
                  activeTab = ".logout";
                  selectedTab = "logout";
                    
	});

});


function clearSession() {

	$('#notification-message').hide();
	localStorage.getItem("baseUrl");
	var outURL = localStorage.getItem("baseUrl") + "/j_spring_security_logout";

	$.ajax({
		url: outURL,
		type: 'POST',
		success: function(resp) {
			window.location = "Home.html";
			$("#loading-icon").removeClass("loading-icon");
			app.showNotification('Signing Out ........', '');
		},
		error: function(e) {
			$("#loading-icon").removeClass("loading-icon");
			window.location = "Home.html";
		}
	});


}


	$(function() {


	$(document).on('click', '.dropdown-menu li', function() {
                  
                  $(".logout-screen").css("display", "none");
                  $('#notification-message').hide();
                  $(".deliverable-feed").css("display", "block");
                  $(".submit-box").hide();
                  $(".submit-box").css("display", "none");
                  $(".submit-success").hide();
                  $(".upcoming-header").hide();

             //     $(".history-sub").show();
                  override = false;
  
		  $(".selectedAsset").text($(this).text());
                  selectedAssetId = $(this).attr("data-value");
                  
            //      app.showNotification(selectedTab, "");

                    
                  console.log(selectedTab + " : is selected tab.");
 
                  if(selectedTab =="deliverable")
	                 getDeliverableRequest( selectedAssetId );
                  else
          	         getSubmissionHistory();

  
       
                console.log(selectedAssetId);
 
	});
});



function addBG(indx){

	$('.color-index'+indx).css('background', getBackgroundColor());



}

function getBackgroundColor(){

	var index = Math.floor((Math.random() * colorCodes.length -1 ) + 1);

	return colorCodes[index];

}

$(function() {

	$(document).on("click", "#backToLogin", function() {

		window.location = "Home.html";


	});


});

$(function () {

    $(document).on("click", "#delete-metric", function() {

    deleteMetricValues();  //actually delete submission
    

});

});


$(function () {

    $(document).on("click", ".submission-name", function() {
              		
  //submissionHistoryArray
       

                override =false;
                
                var submissionHistoryArrayIndex =  $(this).attr("data-value"); 
                
                selectedDeliverableRequest =  submissionHistoryArray["submission"][submissionHistoryArrayIndex]["deliverableRequest"];

                deliverableReqId = selectedDeliverableRequest["id"] ;
       
  
                var id = submissionHistoryArray["submission"][submissionHistoryArrayIndex]["id"];
               
                submissionId = id;
                
                console.log(submissionId);       
             
                $(".submission-feed").html("");
                 
                var bgColor = $(this).parent().parent().prev().children(":first").css("background-color");
                selectedBGColor = bgColor;  


           //   $(".submit-success").show();
             
              
                console.log(" Printing Submission ");
                
                var submission = submissionHistoryArray["submission"][submissionHistoryArrayIndex];

         //       var status  = $(this).parent().next().next().children(":first").text();
                
           //   app.showNotification(status," is the status of jquery.");      
               
                 console.log(submission);
                   
                 selectedSubmission = submission;              

                 getSubmissionDetails( submission ) ;
  
                  $(".fa-refresh").addClass("fa-arrow-left back-button");
                                    $(".back-button").removeClass("fa-refresh");
     
                  
} );

});


function deleteMetricValues(){


               var serviceURL = localStorage.getItem("baseUrl") + deleteSubmissionURL + submissionId + "/delete";
               console.log(serviceURL);

               var methodType = "POST";
               var successHandler = deleteMetricSuccessHandler ;
               var failureHandler = deleteMetricErrorHandler ;
               var dataType = "text" ;
               console.log(selectedDeliverableRequest);   
           
               getDataFromService("" , dataType, serviceURL, methodType, successHandler, failureHandler ) ;



}

 function getUserDetails(){

               var serviceURL = localStorage.getItem("baseUrl") + userServiceURL ;

               var methodType = "GET";
               var successHandler = userDetailsSuccessHandler ;
               var failureHandler = userDetailsErrorHandler ;
               var dataType = "json" ;
         //      console.log(selectedDeliverableRequest);

               getDataFromService("" , dataType, serviceURL, methodType, successHandler, failureHandler ) ;




  }



var deleteMetricSuccessHandler = function deleteMetricSuccess( data ) {

        override = false;
         
         $(".submit-button").attr("disabled", false);  
         $('.submit-spin').removeClass("fa fa-cog fa-spin"); 
 
        console.log(data);
        app.showNotification("Success : Metric values are deleted.", "");
        showSelectedDeliverableRequest(); 
} 

var deleteMetricErrorHandler = function deleteMetricError( data ) {


       app.showNotification(data);
       console.log(data);

}

 var userDetailsSuccessHandler = function userDetailsSuccess( data ) {
                 

          console.log("Printing user details");

          console.log( JSON.stringify(data) ); 
          $("#user-text").html(data["firstName"] + " " + data["lastName"]);          

 } 

 var userDetailsErrorHandler = function userDetailsError( data ) {



 }




  function getSubmissionForDeliverable(){
               var serviceURL = localStorage.getItem("baseUrl") + submissionDeliverableURL + deliverableReqId;

               var methodType = "GET";
               var successHandler = subDeliverableSuccessHandler ;
               var failureHandler = subDeliverableErrorHandler ;
               var dataType = "json" ;
          

               getDataFromService("" , dataType, serviceURL, methodType, successHandler, failureHandler ) ;




     }

      var subDeliverableSuccessHandler = function getDeliverableSubmission(data){
            
   
            //console.log(data);
            //console.log("Printing selected deliverable request");
            //console.log(selectedDeliverableRequest);
          
             selectedSubmission = data ;
             
             $("#status-block").removeClass();
             
             $(".color-label-chars").css("background-color",selectedBGColor);

            //$(".secondary-button").hide();

           if(data["id"]==null)
              
                showSelectedDeliverableRequest();
           
           else {
              

               var submissionText = data.status.status ;
               
               $("#submit-icon").removeClass();
               
               $("#action-button").hide();
                 

                        var secondChar = "";
                       
                        var secondCharIndex = selectedDeliverableRequest["deliverable"]["name"].indexOf(" ");
                         
                        if(secondCharIndex !== -1)
                           secondChar = selectedDeliverableRequest["deliverable"]["name"].charAt(secondCharIndex + 1);

                        var firstChar = selectedDeliverableRequest["deliverable"]["name"].charAt(0);

                        var colorLabelChars = firstChar.toUpperCase() + secondChar.toUpperCase();
                       
                        $(".submit-box").css("display", "block");
                        
                //        $(".submit-box").html("<div class='row row-style-1' style='height: 35%;'><div class='color-label color-index'><label class='deliverable-label' style='background-color: chocolate; border-radius: 50%;'>"+ colorLabelChars +"</label></div> <div style='text-align: center;'><span class='fa fa-clock-o'></span>" + selectedDeliverableRequest["deliverable"]["dueDays"] +"d </div></div><div class='row row-style-1' style='text-align: center; height: 20%;' ><label class='deliverable-label label-align deliverable-label-height' style='font-size: 23px;'>" + getFormattedDeliverableName(selectedDeliverableRequest["deliverable"]["name"]) +"</label></div><div class='row row-style-2' style='text-align:center; height: 25%'><label class='deliverable-label deliverable-label-height label-color'>"+ selectedDeliverableRequest["deliverable"]["description"] +"</label></div></div></div><div class='row row-style-1 button-div' style='height: 20%; vertical-align:bottom'><button class='btn btn-default submit-button' style='width: 100%; background-color: mediumseagreen; color: white; bottom:0; width: 100%; margin: 1%;'> <i id='submit-spin'></i>Submit </button></div>");

                        $(".color-label-chars").text(colorLabelChars);
                         
                        $(".due-days").text(""); 

                        $(".formatted-del-name").text(getFormattedDeliverableName(selectedDeliverableRequest["deliverable"]["name"]));

                        $(".clock-icon").removeClass("fa-clock-o");



               if(data["status"]["statusId"]=="2"){
                   /*            $("#submission-text").text(submissionText);
                               $("#deliverable-text").text("Your metrics for this deliverable is in pending review.");  
                               $("#delete-metric").hide();

                                  
                               $("#circle-border").css("color","#5bc0de"); 
                               $("#submit-icon").addClass("glyphicon glyphicon-hourglass"); 
                               $("#submit-icon").css("color","#5bc0de");   
                               $("#action-button").text("Approve");
                 */
          /*                     $(".description").text("Your metrics for this deliverable is in pending review.");
                               $(".secondary-button").text("Approve");
                               $(".submit-button").hide();
   */
                     }

                    else if(data["status"]["statusId"]=="1"){
                         /*      $("#submisision-text").text("Saved as Draft !");
                               $("#deliverable-text").text("Your metrics for this deliverable has been saved as draft.");
                               $("#delete-metric").show();
                               $("#action-button").show();
                               
                               $("#circle-border").css("color","f0ad4e");
 
                               $("#submit-icon").addClass("fa fa-file-text-o");
                               $("#submit-icon").css("color", "#f0ad4e");
                               $("#action-button").text("Submit for review");
                          */
                          
          
                              $(".description").text("Your metrics for this deliverable has been saved as draft.");
                              $(".secondary-button").text("Submit for review");
                              $(".secondary-button").css("display","block");
                               
                              $("#status-block").addClass("due-days status-block label label-warning");
                              $(".status-block").text("Draft");
                              $(".status-block").css("color", "white");

                              $(".submit-button").css("display","block"); 
                              $(".submit-button").css("background-color","#d9534f");
                              $(".submit-button").text("Delete"); 
                     }
                      
                    else if(data["status"]["statusId"]=="5"){

                          /*      $("#submission-text").text("Submitted");
                                $("#deliverable-text").text("Your metrics for this deliverable has been submitted.");
                                $("#delete-metric").hide();
                                $("#circle-border").css("color","green");

                                $("#submit-icon").addClass("fa fa-check");
                                $("#submit-icon").css("color", "green");
                 /*               $("#action-button").text("Back to draft"); */
            /*                     $(".secondary-button").css("display","block");
                                $(".secondary-button").text("Back to draft");     
                                $(".description").text("Your metrics for this deliverable has been submitted.");
                                $(".submit-button").hide();
           */
                      }             
                                                  
               submissionId = data["id"];
               $(".deliverable-feed").html("");
         //      console.log(JSON.stringify(data));
         //      $(".submit-success").show(); 
                     
             }
             
                     
            

           }


       function getSubmissionDetails(submission){

                   var submissionText = submission.status.status ;
                    
                   var status = submission.status.statusId;

               $("#submit-icon").removeClass();
               $("#action-button").hide();
                 
               $(".submit-box").show();  
             //  $(".clock-icon").css("display","none");
                
               $("#status-block").removeClass();
               $(".status-block").css("color","white");    

               $(".secondary-button").css("display","block");
               $(".clock-icon").removeClass("fa-clock-o"); 
               $(".color-label-chars").css("background-color", selectedBGColor);

       //        console.log("Printing submission for the submission history tab");
       //        console.log(submission);
               
                var secondChar = "";
                var secondCharIndex = -1;
        
                        if( submission["deliverableRequest"] != null )
                        	secondCharIndex = submission["deliverableRequest"]["deliverable"]["name"].indexOf(" ");
                         
                        if(secondCharIndex !== -1)
                            secondChar = submission["deliverableRequest"]["deliverable"]["name"].charAt(secondCharIndex + 1);
                        
                          
                        var firstChar = submission["deliverableRequest"]["deliverable"]["name"].charAt(0);

                        var colorLabelChars = firstChar.toUpperCase() + secondChar.toUpperCase();



                        $(".color-label-chars").text(colorLabelChars);
                         
                        $(".due-days").text(""); 

                        $(".formatted-del-name").text(getFormattedDeliverableName(submission["deliverableRequest"]["deliverable"]["name"]));

                      //  $(".description").text(selectedDeliverableRequest["deliverable"]["description"]);



               if( status =="2"  ){
                             /*  $("#submission-text").text(submissionText);
                               $("#deliverable-text").text("Your metrics for this deliverable is in pending review.");
                               $("#delete-metric").hide();
                               $("#submit-icon").addClass("glyphicon glyphicon-hourglass");
                               $("#submit-icon").css("color","#5bc0de");
                               $("#circle-border").css("color","#5bc0de"); 
                               $("#action-button").text("Approve");
                             */  
                    
                               $(".description").text("Your metrics for this deliverable is in pending review.");
                               $(".secondary-button").text("Send back to draft");        
                               $(".submit-button").hide();  
                                
                               $("#status-block").addClass("due-days status-block label label-info");
                               $(".status-block").text("Pending Review");
                              
                                $(".status-block").css("color", "white");


                     }

                    else if( status === "1" ){
            /*                   $("#submission-text").text("Saved as Draft !");
                               $("#deliverable-text").text("Your metrics for this deliverable has been saved as draft.");
                               $("#delete-metric").show();
                               $("#action-button").show();
                               $("#submit-icon").addClass("fa fa-file-text-o");
                               $("#submit-icon").css("color","#f0ad4e");
                               $("#action-button").text("Submit for review");
                               $("#circle-border").css("color","#f0ad4e");

               */              
    /*                             $(".description").text("Your metrics for this deliverable has been saved as draft.");
                               $(".secondary-button").text("Submit for review");        
                               $(".submit-button").hide();  
                               $(".status-block").removeClass("label-success");
                               $(".status-block").addClass("label-info");
                               $(".status-block").text("Draft");
                               $(".status-block").css("display","block");
  */
  
                     }

            
            
                    else if( status =="5" ){

                            /*    $("#submission-text").text("Submitted");
                                $("#deliverable-text").text("Your metrics for this deliverable has been submitted.");
                                $("#delete-metric").hide();
                                $("#circle-border").css("color","green");
        
                                $("#submit-icon").addClass("fa fa-check");
                                $("#submit-icon").css("color","green");
                                $("#action-button").text("Send back to draft");

                           */
                               
                                $(".secondary-button").text("Send back to draft");     
                                $(".description").text("Your metrics for this deliverable has been submitted.");
                                $(".submit-button").hide();
                                
                                $("#status-block").addClass("due-days status-block label label-success");
                                $(".status-block").css("color", "white");
                                $(".status-block").text("Transacted");
                          

                      }

          //     submissionId = data["id"];
               $(".deliverable-feed").html("");
         //      console.log(JSON.stringify(data));
         //      $(".submit-success").show();



        }
       



      var  subDeliverableErrorHandler = function subDeliverableFailureHandler(data){

           console.log(data);
       } 


	$(function() {
		       
                       	$(document).on('click', '.deliverable-name', function() { 
            
                                    var deliverableRequestArrayIndex =  $(this).attr("data-value");
                                    selectedDeliverableRequest =  deliverableRequestArray["deliverableRequest"][deliverableRequestArrayIndex];
                                    deliverableReqId = selectedDeliverableRequest["id"] ;
                                    
                                    $(".deliverable-feed").css("display", "none");
                                    $(".fa-refresh").addClass("fa-arrow-left back-button");
                                    $(".back-button").removeClass("fa-refresh");
                                    

                                    var bgColor = $(this).parent().parent().prev().children(":first").css("background-color");
                                    override = false;
                                    selectedBGColor = bgColor;
                                    console.log("Background color is. " + bgColor);

                                    getSubmissionForDeliverable();       
                                    //showSelectedDeliverableRequest();
       
	});
});


function showSelectedDeliverableRequest(){
//	console.log("showing data");
                         
                         $(".deliverable-feed").html("");
                         $(".submit-box").hide();
                         $(".submit-box").css("display", "none");
                         $(".history-sub").hide();
								 $(".submit-button").attr("disabled", false);
                         $(".clock-icon").css("display", "block");
                         $(".clock-icon").addClass("fa-clock-o");
                         $(".submit-success").hide();
                         $(".secondary-button").hide();

                         $(".submit-button").css("display","block"); 
                         $(".submit-button").text("Submit");
                         $(".submit-button").css("background-color","mediumseagreen");   
                          
                         $("#status-block").removeClass();
                         $("#status-block").addClass("status-block due-days");
                       
                         $(".status-block").css("color","black");

                        var secondChar = "";
                        var secondCharIndex = selectedDeliverableRequest["deliverable"]["name"].indexOf(" ");
                         
                        if(secondCharIndex !== -1)
                           secondChar = selectedDeliverableRequest["deliverable"]["name"].charAt(secondCharIndex + 1);

                        var firstChar = selectedDeliverableRequest["deliverable"]["name"].charAt(0);
                        var colorLabelChars = firstChar.toUpperCase() + secondChar.toUpperCase();
                       
                        $(".submit-box").css("display", "block");
                        
                //        $(".submit-box").html("<div class='row row-style-1' style='height: 35%;'><div class='color-label color-index'><label class='deliverable-label' style='background-color: chocolate; border-radius: 50%;'>"+ colorLabelChars +"</label></div> <div style='text-align: center;'><span class='fa fa-clock-o'></span>" + selectedDeliverableRequest["deliverable"]["dueDays"] +"d </div></div><div class='row row-style-1' style='text-align: center; height: 20%;' ><label class='deliverable-label label-align deliverable-label-height' style='font-size: 23px;'>" + getFormattedDeliverableName(selectedDeliverableRequest["deliverable"]["name"]) +"</label></div><div class='row row-style-2' style='text-align:center; height: 25%'><label class='deliverable-label deliverable-label-height label-color'>"+ selectedDeliverableRequest["deliverable"]["description"] +"</label></div></div></div><div class='row row-style-1 button-div' style='height: 20%; vertical-align:bottom'><button class='btn btn-default submit-button' style='width: 100%; background-color: mediumseagreen; color: white; bottom:0; width: 100%; margin: 1%;'> <i id='submit-spin'></i>Submit </button></div>");

                        $(".color-label-chars").text(colorLabelChars);
                         
                        $(".due-days").text(selectedDeliverableRequest["deliverable"]["dueDays"] +"d"); 

                        $(".formatted-del-name").text(getFormattedDeliverableName(selectedDeliverableRequest["deliverable"]["name"]));

                        $(".description").text(selectedDeliverableRequest["deliverable"]["description"]);
}



function initializeAppData(){
   getFund(); 
   getAsset();
   getDeliverableRequest();

}

/*

$(function() {

        $(document).on("click", ".fa-clock-o", function() {
               
               $(this).removeClass("fa-clock-o");
               $(this).addClass("fa-envelope-o");
               $(".submit-success").hide();
               $(".header-tab").text("Submission History") ;
               getSubmissionHistory();    

        });


});

*/



$(function() {

        $(document).on("click", ".secondary-button", function() {
               
    //            console.log("Printing submission");

    //            console.log(selectedSubmission);

                var submissionId = selectedSubmission.id;


                $("#secondary-submit-spin").addClass("fa fa-cog fa-spin");
    
                if( $(".secondary-button").text() ==="Send back to draft" ){
                      
                    changeStatus(DRAFT_STATUS, submissionId);
                  

                  }  else if( $(".secondary-button").text() ==="Approve" ){

                    changeStatus(TRANSACTED_STATUS, submissionId);                      

                  }  else if ( $(".secondary-button").text() ==="Submit for review") {
                          
                    changeStatus(PENDING_STATUS, submissionId) ;   

                  }


        });


});


function changeStatus(statusId, submissionId){

    
          var serviceURL = localStorage.getItem("baseUrl") + updateSubmissionURL + "" + submissionId +"/status/" + statusId;
          var methodType = "GET" ;
          var successHandler = statusChangedSuccessHandler ;
          var failureHandler = statusChangedFailureHandler ;
          var dataType = "json" ;

          getDataFromService("", dataType, serviceURL, methodType, successHandler, failureHandler ) ;

}


var statusChangedSuccessHandler = function statusChangedSuccess( data ){


        $("#secondary-submit-spin").removeClass("fa fa-cog fa-spin");
        
        selectedSubmission = data;

       if(data.status.statusId > 1){

               updateTabs(".submission", activeTab);
               activeTab = ".submission";
               selectedTab = "submission";
              
              getSubmissionDetails(data);
              
       }   else {

               updateTabs(".deliverable", activeTab);
               activeTab = ".deliverable";
               selectedTab = "deliverable";

             subDeliverableSuccessHandler(data);

       }

         
       
}


var statusChangedFailureHandler = function statusChangedFailure(){




}



function getSubmissionHistory(){
                    
               $(".submit-success").hide();
      
               var serviceURL = localStorage.getItem("baseUrl") + submissionHistoryURL + selectedAssetId + "/filter";
               var methodType = "GET";
               var successHandler = submissionHistorySuccessHandler ;
               var failureHandler = submissionHistoryErrorHandler ;
               var dataType = "json" ;

               getDataFromService("", dataType, serviceURL, methodType, successHandler, failureHandler ) ;

           
}



$(function() {

        $(document).on("click", ".fa-envelope-o", function() {
           
          $(this).removeClass("fa-envelope-o");
          $(this).addClass("fa-clock-o");
          $(".submission-feed").html("");        

           $(".header-tab").text("Upcoming Deliverables") ;
  
            getDeliverableRequest(selectedAssetId); 

        });

});



function getDeliverableRequest(assetId){

    $(".submit-success").hide();
 
    var serviceURL = localStorage.getItem("baseUrl") + deliverableURL + "request/asset/" + assetId + "?statusId=1";
    var methodType = "GET";
    var successHandler = deliverableSuccessHandler ;
    var failureHandler =  deliverableErrorHandler;
    var dataType = "json";

    getDataFromService("", dataType, serviceURL, methodType, successHandler, failureHandler );

}
$(function() {


	$(document).on('change', '#assetSelect', function() {
                
                  $(".deliverable-feed").html("");
                  $(".submit-box").hide();
                  $(".submit-box").css("display", "none");
                  $(".submit-success").hide(); 
                  $(".upcoming-header").hide();

                  $(".history-sub").show();
                  override = false;  
                                   
                     
		if($(this).find('option:selected').text()==="Please select an asset"){
                     selectedAssetId = 0;
                     selectedAsset  = null;
                     return; 

                }
                       
                 
                selectedAssetId = $(this).find('option:selected').attr("data-value");
                
                 
                selectedAsset = $.grep(assetArray.asset, function(e){ return e.id == selectedAssetId; })[0];
                 
                console.log(selectedAsset);    
                console.log(JSON.stringify(selectedAsset)); 
                  
                if($(".history-icon").hasClass("fa-clock-o")) 
		                  getDeliverableRequest( selectedAssetId );
                else 
                      getSubmissionHistory();        
            



	});

});


$(function() {

   $(document).on('click', '.back-button', function() {
                    
                    console.log("clicked back-button"); 
                    $(".submit-success").hide();
                    $(".submit-box").hide();
                    $(".submit-box").css("display", "none");
                    $(".deliverable-feed").css("display", "block");
                    $(".submission-feed").html("");  
                    $(".fa-refresh").addClass("fa-arrow-left back-button");
                    $(".back-button").removeClass("fa-refresh");
 
                    $(".back-button").removeClass("fa-arrow-left");     
                    $(".back-button").addClass("fa-refresh");
                    $(".fa-refresh").removeClass("back-button");
                    
	//	    $(".header-tab").text("Upcoming Deliverables") ;
          //          $(".history-icon").removeClass("fa fa-envelope-o");   
          //          $(".history-icon").addClass("fa fa-clock-o"); 
                   if(selectedTab == "deliverable")		
                      getDeliverableRequest( selectedAssetId );
                   else 
                      getSubmissionHistory();    

   });

 });



	$(function () {

            $(document).on('click', '.fa-refresh', function (){ 
                $(".fa-refresh").addClass("fa-spin");
		if(selectedTab =="deliverable")
                         getDeliverableRequest( selectedAssetId );
                  else
                         getSubmissionHistory();
              
               	});
            
	});


 $(function() {

   $(document).on('click', '.submit-button', function() {
    
    $(this).attr("disabled", true);  
    $('.submit-spin').addClass("fa fa-cog fa-spin");

    if($(this).text() === "Delete"){
        
      deleteMetricValues();    
      return;
    }

  
               
    resetGlobal();
    readAllNamedGroups();
    
	});
});


$(function () {
    
    $(document).on('change', '#checkbox', function() { 
    
    override  = this.checked ? "true" : "false";
    console.log( override );
   });

});

$(function() {
	$("#button1").click(function() {

		//   loadDataAndCreateChart();
	
	     readAllNamedGroups();
//           testSubmission();   
	});

});


function testSubmission(){ 
        Submission.Submission.Id = "";
        Submission.Submission.Asset = "36";
        Submission.Submission.DeliverableRequest = "";
        Submission.Submission.Metrics = "";
        Submission.Submission.Status ="1";
        console.log(JSON.stringify(Submission));
        postSubmission(JSON.stringify(Submission));
}

function postSubmission(data) {

    var successHandler = submissionSuccessHandler ;
    var failureHandler = submisisonErrorHandler;
    var dataType = "json";
    var serviceURL  = localStorage.getItem("baseUrl") +  submissionURL + selectedAssetId +  "/submit?override=" + override ;
    var methodType =  "POST";

    getDataFromService( data, dataType, serviceURL, methodType, successHandler, failureHandler );




}


function getFormattedDate(ufDate){

       console.log(ufDate);

       var date = new Date(1899,11,31);
       var dayCount = ufDate;
  
       date.setDate( date.getDate() + dayCount -1 );
  
       var fDate = date.getFullYear() + "-" + formatMonth(date.getMonth()) + "-" + formatDate(date.getDate())  + "T00:00:00+0000";
       
        console.log(fDate);
                    
       return fDate;

}


function formatMonth(month){
 
   var month = parseInt(month) + 1 ;
   
   return formatDate(month);


}



function formatDate(date){

   var date = parseInt(date);

   if(date > 9)  return date;
   
   else return "0" + date;

}

function detectBrowser() {

	"use strict";

	// Detecting IE
	var oldIE = false;
	if ($('html').is('.ie6, .ie7, .ie8, .ie9')) {
		oldIE = true;
	}

	if (oldIE) {
		window.location = "Error.html";
	}


}


function readAllNamedGroups() {


	bindDatarangeGroup();

}


function  checkForLoad() {
    if (loadedDataGroup && loadedDateGroup && loadedScenario && loadedPeriodType) {
        try{           
			makeJson();
	     } catch (err){
			
		   resetGlobal(); 
		   console.log("Error in making Json");	 
		}	 
	}
}

	function testValid(data){
                 
                  var regex = /^[0-9.,]+$/;
                  if(regex.test(data))
                         return "true" ;
                 console.log(data);
                return "false" ;

	}


	function resetGlobalVars(){


                    metrics = {

        			metricGroup: []

					};
              


                   
                    arrayOfMetricValue = {

                            "metricValue" : []
                                };



                    metricValue = {

                        "metric": "",
                        "value": ""
              };
 
                   metric = {
				       		"name": "",
				       		"code": ""                 
              };

         }




function makeJson() {

	var date = 0;
	// dg = datarange group
	for (var dg = 0; dg < dataGroupArray.length; dg++) {

		var bindVar = dataGroupArray[dg];
		var colRange = bindVar[0].length;
		var rowRange = bindVar.length;
                   
      console.log(colRange +":"+ rowRange);            
		
      for (var col = 2; col < colRange; col++) {
			var tempArrayOfMetricValue = JSON.parse(JSON.stringify(arrayOfMetricValue));
			
		for (var row = 0; row < rowRange; row++) {

			var tempMetric = JSON.parse(JSON.stringify(metric));
			tempMetric.code = bindVar[row][1];
			tempMetric.name = bindVar[row][0];
			
      	var tempMetricValue = JSON.parse(JSON.stringify(metricValue));
      	tempMetricValue.metric = tempMetric;
			tempMetricValue.value = bindVar[row][col];

   //    console.log(tempMetric); 
         
         if(tempMetricValue.value === null || tempMetricValue.value === "")
         	continue;    
         
         if(testValid(tempMetricValue.value) ==="false")
	         continue;                         
                                   
			tempArrayOfMetricValue.metricValue.push(tempMetricValue);
                                 
                                         
		}
	
		var periodTup = dateArray[dg][0][col - 2];
		var periodTypeTup = periodArray[dg][0][0];									
      var tempPeriod = JSON.parse(JSON.stringify(period));
      var tempPeriodType = JSON.parse(JSON.stringify(periodType));      
		
		tempPeriod.date = getFormattedDate(periodTup);
		tempPeriodType.id = periodTypeTup;
		tempPeriod.periodType = tempPeriodType;  
		
		ScenarioTup = scenarioArray[dg][0][0];
      var tempScenario =  JSON.parse(JSON.stringify(scenario));
      tempScenario.scenarioID = ScenarioTup; 
                       
      var tempMetricGroup = JSON.parse(JSON.stringify(metricGroup));
                            
		tempMetricGroup.arrayOfMetricValue = tempArrayOfMetricValue;
		tempMetricGroup.period = tempPeriod;  
      tempMetricGroup.scenario = tempScenario;   
					
		metrics.metricGroup.push(tempMetricGroup);

		}


	} 


        var metricValuesLength = metrics.metricGroup[0].arrayOfMetricValue.metricValue.length;


       
        //selectedDeliverableRequest["date"] = selectedDeliverableRequest["date"] + "T00:00:00+0000";
       // selectedDeliverableRequest["dueDate"] = selectedDeliverableRequest["dueDate"] + "T00:00:00+0000";        

        status1.status = "Draft" ;
        status1.statusId = 1 ;
   
       
        var date = new Date(); 
        //var fDate = formatDate(date.getFullYear()) + "-" + formatMonth(date.getMonth()) + "-" + date.getDate() + "T00:00:00+0000";

        Submission.id = "";
        //Submission.dateTime = fDate;
        Submission.asset = selectedAsset;      
        Submission.deliverableRequest = selectedDeliverableRequest;
        Submission.metrics = metrics;    
        Submission.status = status1; 
    
          
        if(metricValuesLength > DEFAULT_METRIC_VALUE_LENGTH)    
	        postSubmission(JSON.stringify(Submission));
        else {
             
               $('.submit-spin').removeClass("fa fa-cog fa-spin");
               $(".submit-button").attr("disabled", false);

               app.showNotification("No metrics values were read from the excel sheet.","");

   }

}

function bindDatarangeGroup() { // Nodejs async module simplifies this
	Office.context.document.bindings.addFromNamedItemAsync("datarangegroup" + groupCount, "matrix", {
		id: 'datarangegroup' + groupCount
	}, function(result) {
		if (result.status == 'succeeded') {
			console.log('Added new binding with type: ' + result.value.type + ' and id: ' + result.value.id);
			groupCount++;
			bindDatarangeGroup();
		} else bindDaterangeGroup();
		

	});

}

function bindDaterangeGroup() {

	Office.context.document.bindings.addFromNamedItemAsync("daterangegroup" + dateGroupCount, "matrix", {
		id: 'daterangegroup' + dateGroupCount
	}, function(result) {
		if (result.status == 'succeeded') {
			console.log('Added new binding with type: ' + result.value.type + ' and id: ' + result.value.id);
			dateGroupCount++;
			bindDaterangeGroup();
		} else bindScenario();
	
	});

}

function bindScenario() {

	Office.context.document.bindings.addFromNamedItemAsync("scenario" + scenarioCount, "matrix", {
		id: 'scenario' + scenarioCount
	}, function(result) {
		if (result.status == 'succeeded') {
			console.log('Added new binding with type: ' + result.value.type + ' and id: ' + result.value.id);
			scenarioCount++;
			bindScenario();
		} else bindPeriodType();
	

	});

}

function bindPeriodType() {

	Office.context.document.bindings.addFromNamedItemAsync("periodtype" + periodCount, "matrix", {
		id: 'periodtype' + periodCount
	}, function(result) {
		if (result.status == 'succeeded') {
			console.log('Added new binding with type: ' + result.value.type + ' and id: ' + result.value.id);
			periodCount++;
			bindPeriodType();
		} else {getData();
		getDate();
		getScenario();
		getPeriodType();
	
}
	});


}


function getFormattedDeliverableName(name){


if(name.length > 22)
   return name.slice(0,22) + "...";
else return name;

}





function getPeriodType() {

	for (var pt = 1; pt < periodCount; pt++)
	readPeriodTypeFromAsync(pt);

	var interval = setInterval(function() {
		if (periodCounter == periodCount - 1) {
			clearInterval(interval);
			loadedPeriodType = true;
                        console.log("loaded period Type, loadedPeriodType" + loadedPeriodType);
                        checkForLoad();
		}
	}, 100);


}

function getScenario() {

        console.log("getting scenario data.");
        console.log("initial scenario  Count" + scenarioCount);    
                        
	for (var sc = 1; sc < scenarioCount; sc++)
	readScenarioFromAsync(sc);

	var interval = setInterval(function() {

		if (scenarioCounter == scenarioCount - 1) {
			clearInterval(interval);
			loadedScenario = true;
                        console.log("loaded scenario, loadedScenario" + loadedScenario); 
                        checkForLoad();
		}
	}, 100);
}


function getData() {
         
	
       for (var gc = 1; gc < groupCount; gc++)
	readGroupDataFromAsync(gc);

	var interval = setInterval(function() {
		if (dataCounter == groupCount - 1) {
			clearInterval(interval);
			loadedDataGroup = true;
			console.log("loaded data, loadeddatagroup " + loadedDataGroup);
                        checkForLoad();
		}
	}, 100);

}

function getDate() {

	for (var dc = 1; dc < dateGroupCount; dc++)
	readDateGroupFromAsync(dc);

	var interval = setInterval(function() {
		if (dateCounter == dateGroupCount - 1) {
			clearInterval(interval);
			loadedDateGroup = true;
			console.log("loaded date, loadedDateGroup " + loadedDateGroup);
                        checkForLoad();     
		}
	}, 100);

}


function readPeriodTypeFromAsync(pt) {

	Office.select("bindings#periodtype" + pt).getDataAsync(function(asyncResult) {

		if (asyncResult.status == 'succeeded') {
			periodArray.push(asyncResult.value);
			periodCounter++;
                        console.log("read data from period"+pt); 

		} else {

                                 console.log("error reading period"+ pt);
		}
	});

}

function readScenarioFromAsync(sc) {

	Office.select("bindings#scenario" + sc).getDataAsync(function(asyncResult) {

		if (asyncResult.status == 'succeeded') {
			scenarioArray.push(asyncResult.value);
			scenarioCounter++;
                        console.log("scenario array testing" + asyncResult.value );     
                        console.log("read data data from scenario"+sc);      

		} else {

                       console.log("error reading scenario" +sc);
		}
	});

}


function readDateGroupFromAsync(dc) {


	Office.select("bindings#daterangegroup" + dc).getDataAsync(function(asyncResult) {

		if (asyncResult.status == 'succeeded') {

			
			dateArray.push(asyncResult.value);
			dateCounter++;




		} else {


                            console.log("error reading "+ dc);
		}

	});
}

function readGroupDataFromAsync(gc) {
                   
            console.log("calling async data");
	Office.select("bindings#datarangegroup" + gc).getDataAsync(function(asyncResult) {
                  
                 console.log("printing value " + gc);
        
                 console.log(asyncResult.value);             
                     
		if (asyncResult.status == 'succeeded') {
                        console.log("success!") ; 
			dataGroupArray.push(asyncResult.value);
			dataCounter++;
                        console.log("Counter value is" + dataCounter);  

		} else {

                          console.log("failed");
		}


	});


}

function getAsset(){

	       var serviceURL = localStorage.getItem("baseUrl") + assetURL ;
               var methodType = "GET";
               var successHandler = assetSuccessHandler ;
               var failureHandler = assetErrorHandler ;
               var dataType = "json" ;
           
               getDataFromService( "" , dataType, serviceURL, methodType, successHandler, failureHandler ) ;





}

var assetSuccessHandler = function getAssetSuccessHandler(data){
  
   $(".dropdown-menu").html(""); 

   assetArray = data ;

   $("#assetSelect").append("<option>Please select an asset</option>");
 
   $.each(data, function (key, value) {
       console.log(key);
      $.each(value, function (index, innerValue) {
      //  $("#assetSelect").append("<option data-value='" + innerValue["id"] + "'>" + innerValue["name"] + "</option>");
            $(".dropdown-menu").append("<li data-value='" + innerValue["id"] + "'>" + innerValue["name"] + "</li>");    
     });
});

               
       console.log(JSON.stringify(data));


}


var assetErrorHandler = function assetErrorHandler(data){

      console.log(JSON.stringify(data)); 
}

var fundSuccessHandler = function getFundSuccessHandler(data){
       
      $.each(data, function (key, value) {
       console.log(key);
      $.each(value, function (index, innerValue) {
        $("#fundSelect").append("<option data-value='" + innerValue["fundId"] + "'>" + innerValue["fundName"] + "</option>");
     });
});

       
       console.log(JSON.stringify(data)); 
}


var fundErrorHandler = function fundErrorHandler(data){

      console.log(data);
}


var submissionSuccessHandler = function getSubmissionSuccessHandler(data){

	$('.submit-spin').removeClass("fa fa-cog fa-spin");
	$('#notification-message').hide();
	$('.submit-box').hide();
	$(".submit-box").css("display", "none");
 
	submissionId = data["id"];
	$(".submit-button").attr("disabled", false);

   subDeliverableSuccessHandler(data);
   app.showNotification("Data submitted successfully.", '');
}

var submisisonErrorHandler = function submissionErrorHandler(data){
         
 $('.submit-spin').removeClass("fa fa-cog fa-spin");
       
       app.showNotification(data, '');
       $(".submit-button").attr("disabled", false);
       $(".override-row").remove();
       if(data.indexOf("override") > -1){

          $(".submit-button").text("Override and Submit");
          override = true;   

}
}



var deliverableSuccessHandler = function getDeliverableSuccessHandler(data){
  var isEmpty = true;
  var indx = 0;
  deliverableRequestArray = data;


 $(".fa-refresh").removeClass("fa-spin");

 $(".deliverable-feed").html("");
 $(".submission-feed").html("");
   $(".logout-screen").hide();

if(selectedTab ==="deliverable"){
 
 $.each(data, function (key, value) {
       console.log(key);
       $.each(value, function (index, innerValue) {
                
                isEmpty = false;
                var secondChar = "";
                var secondCharIndex = "";

                if( innerValue["deliverable"] != null )
                  innerValue["deliverable"]["name"].indexOf(" ");
                
                if(secondCharIndex !== -1)
                  secondChar = innerValue["deliverable"]["name"].charAt(secondCharIndex + 1);
                  
                var firstChar = innerValue["deliverable"]["name"].charAt(0);

   
                var colorLabelChars = firstChar.toUpperCase() + secondChar.toUpperCase();

 					 var templateURL = "";
					 if (innerValue["deliverable"]["template"]!=null) {
					 	var templateId = innerValue["deliverable"]["template"]["id"];
						templateURL = "<a title='Get Template' href='"+localStorage.getItem("baseUrl") +fileURL+templateId+"' class='deliverable-label-1 deliverable-label-height label-color' style='text-align:left; color: #336699' '>"+
						 					"<i class='glyphicon glyphicon-file'></i> Template"+
											"</a>";
					}					 
					
					 
					 					 
					 
          $(".deliverable-feed").append(
          "<div class='row row-style-1'>"+
          
          	"<div class='col-xs-3 col-style-1'>"+
          		"<div class='color-label-1 color-index"+ indx +"'><label class='deliverable-label-1'>"+ colorLabelChars +"</label></div>"+
          		"<div style='text-align: center;'><span class='fa fa-clock-o'></span> " + innerValue["deliverable"]["dueDays"] +"d </div>"+
          	"</div>"+
				
          	"<div class='col-xs-9 col-style-2'>"+
          		"<div class='row' style='margin-top :-10px;'>"+
          			"<label class='deliverable-label-1 label-align deliverable-label-height deliverable-name' data-value="+ indx  +">" + getFormattedDeliverableName(innerValue["deliverable"]["name"]) +"</label>"+	
          		"</div>"+
          		"<div class='row row-style-2'><label class='deliverable-label-1 deliverable-label-height label-color' style='text-align:left;'>"+ innerValue["deliverable"]["description"] +"</label></div>"+
          		"<div>"+templateURL+"</div>"+
        		"</div>"+
          "</div>"+
          
          "<hr style='width:50%; margin-bottom : 40px;'>");
          
           indx++;
           addBG(indx-1);
     });

});

	if(isEmpty) $(".deliverable-feed").append("<div class='row' style='color : gray ;text-align: center; font-size: 63px;line-height : 135px; width : 135px; margin: 0 auto !important; border : solid 7px; border-radius : 50%; height: 135px'>" +
"<i class='glyphicon glyphicon-inbox' style='text-align: center; color : gray; line-height : 123px;'></i> </div><div class='row' style='text-align : center;'><label class='no-deliverable'>No upcoming deliverable for the selected asset.</label>");

  }
}


var deliverableErrorHandler = function deliverableErrorHandler(data){
      $(".fa-refresh").removeClass("fa-spin");

      console.log(data);
}

var submissionHistorySuccessHandler = function getSubmissionHistorySuccessHandler(data){
 
 var isEmpty = true;
 var indx = 0;
 submissionHistoryArray = data;

 $(".fa-refresh").removeClass("fa-spin");

 $(".deliverable-feed").html("");


 $(".submission-feed").html("");
 
  
 if(selectedTab ==="submission") {
      $.each(data, function (key, value) {
    
     $.each(value, function (index, innerValue) {
                isEmpty = false;
                var dateLength = innerValue["dateTime"].length;
                console.log("Printing submission");
                console.log(innerValue);        


                var secondChar = "";
                var secondCharIndex = -1;
                var firstChar ="";
                var colorLabelChars = "SS";
                if ( innerValue["deliverableRequest"] == null )
                     return;

                if ( innerValue["deliverableRequest"] !== null )
                 	secondCharIndex = innerValue["deliverableRequest"]["deliverable"]["name"].indexOf(" ");
                
                if( secondCharIndex !== -1 )
                  	secondChar = innerValue["deliverableRequest"]["deliverable"]["name"].charAt(secondCharIndex + 1);


		 if ( innerValue["deliverableRequest"] !== null )
			 firstChar = innerValue["deliverableRequest"]["deliverable"]["name"].charAt(0);
 
                if(firstChar != "" && secondChar != "")    
                         colorLabelChars = firstChar.toUpperCase() + secondChar.toUpperCase();

          


//                var submissionDate = innerValue["dateTime"].slice(dateLength-2,dateLength);
                var submissionNum = indx+1;
                var deliverableName = innerValue["deliverableRequest"]["deliverable"]["name"];
                var statusId = innerValue.status.statusId;
                var labelType; 
                if(statusId == "1")
                    labelType = "label-warning";
                else if (statusId == "2")
                    labelType = "label-info";
                else if (statusId == "5")
                    labelType = "label-success";     
                  
 
  $(".submission-feed").append("<div class='row row-style-1' style='margin-bottom : 20px;'><div class='col-xs-3 col-style-1'><div class='color-label-1 color-index"+ indx +"'><label class='deliverable-label-1'>"+ colorLabelChars +"</label></div></div><div class='col-xs-9 col-style-2' style='margin-top : -15px;'><div class='row'><label class='deliverable-label-1 label-align deliverable-label-height submission-name' data-value="+ indx +">" + deliverableName  +"</label></div><div class='row row-style-2'><i class='fa fa-calendar-check-o' style='font-size:15px; margin-top :4px;'></i><label class='deliverable-label-1 deliverable-label-height label-color' style='margin-left: 10px;'>"+ formatSubmissionDate( innerValue["dateTime"] )+"</label></div><div class='row row-style-2' style ='margin-top : -5.5px !important; font-size : 15px;'><span class='label " + labelType + " sub-status'>" + innerValue.status.status + "</span> </div></div></div><hr style='width:50%; margin-bottom : 40px;'>");
           indx++;
           addBG(indx-1);
     });

});
        if(isEmpty) $(".submission-feed").append("<div class='row' style='color : gray; text-align: center; font-size: 63px;line-height : 135px; width : 135px; margin: 0 auto !important; border : solid 7px; border-radius:50%;height :135px;'>" +
 "<i class='glyphicon glyphicon-inbox' style='text-align: center; color :gray; line-height : 123px'></i> </div><div class='row' style='text-align : center;'><label class='no-deliverable'>No submissions for the selected asset.</label></div>");

$(".logout-screen").hide();   //late late binding
}

}

   function formatSubmissionDate( ufDate ){
						
                   return  moment(ufDate,"YYYYY-MM-DDTHH:mm:ss").format('MMM Do YYYY');
                                       
   }



 var submissionHistoryErrorHandler = function getSubmissionHistoryErrorHandler(data){
                   
 $(".fa-refresh").removeClass("fa-spin");


  } 

function getDataFromService( data, dataType, serviceURL, methodType, successHandler, failureHandler ) {

 var basicAuth = customStorage;


  $.ajax({
                type: methodType,
                data : data,    
                dataType : dataType, 
                contentType: "application/json; charset=utf-8", 
                crossDomain: true,
                url: serviceURL,
		beforeSend: function(xhr) {
                        xhr.setRequestHeader("Authorization", basicAuth);
                },

                success: function(data) {
                        
                         successHandler(data);
                },

                error: function(XMLHttpRequest, textStatus, errorThrown) {
                            // var err = eval("(" + XMLHttpRequest.responseText + ")");
                             console.log(XMLHttpRequest["responseText"]);
                            console.log(errorThrown);
                            console.log(textStatus);            
                            failureHandler(XMLHttpRequest["responseText"]); 
                
                }
                 
         
        });

}


function basicAuthentication() {

	$('#notification-message').hide();

	var inputURL = $("#url").val().trim();


	if (inputURL.charAt(0) != "/" || inputURL !== "") {

		if (inputURL.slice(-1) === "/") {

			inputURL = inputURL.substring(0, inputURL.length - 1);
		}

		if (inputURL.substring(0, 5) != "https") {

			if (inputURL.substring(0, 4) != "http") inputURL = "https://" + inputURL;

			//	 else {
			//		 inputURL = "https://" + inputURL.substring(7, inputURL.length);
			//	 }
		}

	}

	var serviceURL = inputURL + fundURL;

	if (inputURL !== "https://") localStorage.setItem("baseUrl", inputURL);

	var userName = $("#uname").val().trim();

	var passWord = $("#pwd").val().trim();

	if (userName === "") {
		app.showNotification("Please enter the user name", '');
		return;
	} else if (passWord === "") {
		app.showNotification("Please enter the password", '');
		return;
	}

	$(".home-page").hide();
	$("#loading-icon").addClass("loading-icon");

	$("#loginIcon").removeClass();

	$("#loginIcon").addClass('glyphicon glyphicon-cog spin');

	var basicAuth = make_base_auth(userName, passWord);
	customStorage = basicAuth;

	$.support.cors = true;

	$.ajax({
		type: "GET",

		dataType: "xml",

		crossDomain: true,
		url: serviceURL,
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Authorization", basicAuth);
		},
		success: function(data) {
			$("#loading-icon").removeClass("loading-icon");
			$(".home-page").hide();
			$(".wrapper-class").show();
			loadMainPage();
			//document.getElementById("loginForm").submit();
		},

		error: function(XMLHttpRequest, textStatus, errorThrown) {
			$(".home-page").show();
			$("#loading-icon").removeClass("loading-icon");

			app.showNotification("Error : ", "Unable to login. Please enter correct credentials.");
			$("#loginIcon").removeClass();
			$("#loginIcon").addClass('glyphicon glyphicon-log-in');



		}

	});

}



 function loadMainPage() {


 getAsset();

 $(".history-sub").show();
 $(".upcoming-header").show();
 $(".wrapper-class").show();


//readAllNamedGroups();

}


   function make_base_auth(user, pass) {
                var tok = user + ':' + pass;

                var hash = $.base64.encode(tok);
                return "Basic " + hash;

        }


function isValidEmailAddress(emailAddress) {
	var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
	return pattern.test(emailAddress);
}

function basicSignUp() {

	$('#notification-message').hide();

	if ($("#entry_986814855").val().trim() === "") {
		app.showNotification("Please enter your name !", '');
		return;
	} else if ($("#entry_2097667227").val().trim() === "") {
		app.showNotification("Please enter your fund's name !", '');
		return;
	} else if ($("#entry_1464001145").val().trim() === "" || !isValidEmailAddress($("#entry_1464001145").val().trim())) {
		app.showNotification("Please enter your email id !", '');
		return;
	}

	document.getElementById("signupForm").submit();
	window.location = "Success.html";

	/* $.ajax({
		url: "https://docs.google.com/forms/d/1MHv7Ii0VmPh2GkY43DN3m-6vk_5GpFNajT2bZdgMUS0/formResponse",
		method : "POST",
		success: function() {
          document.getElementById("signupForm").submit();
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {

			app.showNotification("Unable to process your request.", textStatus);
		}
	});
*/

}
